
public class ParseString
{

    public static int parse(String s)
    {
        if(s.length () == 1) {
            //return Integer.parseInt (s);
            // Base case
            return s.charAt (0) - '0';
        }else{
            // Recursive case
            
            int count = 1;
            for(int i = 1; i < s.length(); ++ i)
            {
                char c = s.charAt (i);
                if(c == '('){
                    ++count;
                }else if (c == ')'){
                    --count;
                }else if ((c == '*' || c == '+') && count == 1){
                    // Found "middle"
                    String s1 = s.substring(1,i);
                    String s2 = s.substring(i+1, s.length()-1);
                    
                    int r1 = parse(s1);
                    int r2 = parse(s2);
                    
                    switch (c)
                    {
                        case '*':
                            return r1 * r2;
                        case '+':
                            return r1 + r2;
                    }
                }
            }
        }
        return 0;
        
    }
    /**
     * @param args
     */
    public static void main(String[] args)
    {
        String strg = "(5+(2*3))";
        
        System.out.println(parse(strg));
    }

}
